"use strict";window.jQuery.each(Waypoint.adapters,function(e,i){describe(i.name+" adapter: ",function(){describe("Waypoint",function(){var t,r,a,l,e,c=window.jQuery;function n(){t=!0}function o(){return t}beforeEach(function(){Waypoint.Adapter=i.Adapter,loadFixtures("standard.html"),r=c(window),t=!1,a=null}),afterEach(function(){Waypoint.destroyAll(),r.scrollTop(0).scrollLeft(0)}),describe("new Waypoint()",function(){it("errors out",function(){expect(function(){a=new Waypoint}).toThrow()})}),describe("new Waypoint(options)",function(){it("returns an instance of the Waypoint class",function(){a=new Waypoint({element:document.getElementById("same1"),handler:function(){}}),expect(a instanceof Waypoint).toBeTruthy()}),it("requires the element option",function(){expect(function(){a=new Waypoint({handler:function(){}})}).toThrow()}),it("requires the handler option",function(){expect(function(){a=new Waypoint({element:document.getElementById("same1")})}).toThrow()}),it("triggers down on new already-reached waypoints",function(){runs(function(){l=c("#same2"),r.scrollTop(l.offset().top+1),a=new Waypoint({element:l[0],handler:function(e){t="down"===e}})}),waitsFor(o,"callback to trigger")})}),describe("handler option",function(){var t;beforeEach(function(){l=c("#same1"),t=null,a=new Waypoint({element:l[0],handler:function(e){t=e}})}),it("triggers with direction parameter",function(){runs(function(){r.scrollTop(l.offset().top)}),waitsFor(function(){return"down"===t},"down to trigger"),runs(function(){r.scrollTop(l.offset().top-1)}),waitsFor(function(){return"up"===t},"up to trigger")})}),describe("offset option",function(){beforeEach(function(){l=c("#same1")}),it("takes a px offset",function(){runs(function(){a=new Waypoint({element:l[0],handler:n,offset:50}),r.scrollTop(l.offset().top-51),expect(t).toBeFalsy(),r.scrollTop(l.offset().top-50)}),waitsFor(o,"callback to trigger")}),it("takes a % offset",function(){var e=l.offset().top-.37*Waypoint.viewportHeight();runs(function(){a=new Waypoint({element:l[0],handler:n,offset:"37%"}),r.scrollTop(e-1),expect(t).toBeFalsy(),r.scrollTop(e)}),waitsFor(o,"callback to trigger")}),it("takes a function offset",function(){runs(function(){a=new Waypoint({element:l[0],handler:n,offset:function(){return-c(this.element).height()}}),r.scrollTop(l.offset().top+l.height()-1),expect(t).toBeFalsy(),r.scrollTop(l.offset().top+l.height())}),waitsFor(o,"callback to trigger")}),it("takes a bottom-in-view function alias",function(){var e=l.offset().top+l.outerHeight()-Waypoint.viewportHeight();runs(function(){a=new Waypoint({element:l[0],handler:n,offset:"bottom-in-view"}),r.scrollTop(e-1),expect(t).toBeFalsy(),r.scrollTop(e)}),waitsFor(o,"callback to trigger")})}),describe("context option",function(){beforeEach(function(){r=c("#bottom"),l=c("#inner3")}),it("works with px offset",function(){a=new Waypoint({element:l[0],handler:n,context:r[0],offset:10}),runs(function(){r.scrollTop(189),expect(t).toBeFalsy(),r.scrollTop(190)}),waitsFor(o,"callback to trigger")}),it("works with % offset",function(){a=new Waypoint({element:l[0],handler:n,context:r[0],offset:"100%"}),runs(function(){r.scrollTop(149),expect(t).toBeFalsy(),r.scrollTop(150)}),waitsFor(o,"callback to trigger")}),it("works with function offset",function(){a=new Waypoint({element:l[0],handler:n,context:r[0],offset:function(){return c(this.element).height()/2}}),runs(function(){r.scrollTop(149),expect(t).toBeFalsy(),r.scrollTop(150)}),waitsFor(o,"callback to trigger")}),it("works with bottom-in-view offset alias",function(){a=new Waypoint({element:l[0],handler:n,context:r[0],offset:"bottom-in-view"}),runs(function(){r.scrollTop(249),expect(t).toBeFalsy(),r.scrollTop(250)}),waitsFor(o,"callback to trigger")})}),describe("horizontal option",function(){var t;beforeEach(function(){t=null,l=c("#same1"),a=new Waypoint({element:l[0],horizontal:!0,handler:function(e){t=e}})}),it("triggers right/left directions",function(){runs(function(){r.scrollLeft(l.offset().left)}),waitsFor(function(){return"right"===t},"right direction to trigger"),runs(function(){r.scrollLeft(l.offset().left-1)}),waitsFor(function(){return"left"===t})})}),describe("continuous option",function(){var e,t,n,o;function i(){n+=1,o=this}beforeEach(function(){l=c("#same1"),e=c("#near1"),n=0,a=new Waypoint({element:l[0],continuous:!1,handler:i}),t=new Waypoint({element:e[0],continuous:!1,handler:i})}),it("does not trigger the earlier waypoint",function(){runs(function(){r.scrollTop(e.offset().top)}),waitsFor(function(){return n},"later callback to trigger"),runs(function(){expect(n).toEqual(1),expect(o).toEqual(t)})}),it("prevents earlier trigger on refresh",function(){runs(function(){l.css("top","-1px"),e.css("top","-2px"),Waypoint.refreshAll()}),waitsFor(function(){return n},"later callback to trigger"),runs(function(){expect(n).toEqual(1),expect(o).toEqual(a)})})}),describe("with window as the waypoint element",function(){beforeEach(function(){l=c(window),a=new Waypoint({element:l[0],offset:-l.height(),handler:n})}),it("triggers waypoint",function(){runs(function(){l.scrollTop(l.height()+1)}),waitsFor(o,"callback to trigger")})}),describe("#disable()",function(){beforeEach(function(){l=c("#same1"),a=new Waypoint({element:l[0],handler:n}),e=a.disable()}),it("returns the same waypoint object for chaining",function(){expect(e).toEqual(a)}),it("disables callback triggers",function(){runs(function(){r.scrollTop(l.offset().top)}),waits(50),runs(function(){expect(t).toBeFalsy()})})}),describe("#enable()",function(){beforeEach(function(){l=c("#same1"),(a=new Waypoint({element:l[0],handler:n})).disable(),e=a.enable()}),it("returns the same waypoint instance for chaining",function(){expect(e).toEqual(a)}),it("enables callback triggers",function(){runs(function(){r.scrollTop(l.offset().top)}),waitsFor(o,"callback to trigger")})}),describe("#destroy()",function(){beforeEach(function(){l=c("#same1"),a=new Waypoint({element:l[0],handler:n}),e=a.destroy()}),it("returns undefined",function(){expect(e).toBeUndefined()}),it("no longer triggers callbacks",function(){runs(function(){r.scrollTop(l.offset().top)}),waits(50),runs(function(){expect(t).toBeFalsy()})})}),describe("#previous",function(){beforeEach(function(){l=c("#same1"),a=new Waypoint({element:l[0],handler:n})}),it("calls previous on the waypoint group",function(){spyOn(a.group,"previous"),a.previous(),expect(a.group.previous).toHaveBeenCalledWith(a)}),it("returns the group call results",function(){expect(a.previous()).toBeNull()})}),describe("#next",function(){beforeEach(function(){l=c("#same1"),a=new Waypoint({element:l[0],handler:n})}),it("calls next on the waypoint group",function(){spyOn(a.group,"next"),a.next(),expect(a.group.next).toHaveBeenCalledWith(a)}),it("returns the group call results",function(){expect(a.next()).toBeNull()})}),describe("Waypoint.viewportHeight()",function(){it("returns window innerHeight if it exists",function(){var e=Waypoint.viewportHeight();window.innerHeight?expect(e).toEqual(window.innerHeight):expect(e).toEqual(document.documentElement.clientHeight)})}),describe("Waypoint.viewportWidth()",function(){it("returns client width",function(){var e=document.documentElement.clientWidth;expect(Waypoint.viewportWidth()).toEqual(e)})}),describe("Waypoint.refreshAll()",function(){it("is an alias for Waypoint.Context.refreshAll",function(){spyOn(Waypoint.Context,"refreshAll"),Waypoint.refreshAll(),expect(Waypoint.Context.refreshAll).toHaveBeenCalled()})}),describe("Waypoint.destroyAll()",function(){it("calls destroy on all waypoints",function(){var e=new Waypoint({element:c("#same1")[0],handler:function(){}});a=new Waypoint({element:c("#same1")[0],handler:function(){}}),spyOn(e,"destroy").andCallThrough(),spyOn(a,"destroy").andCallThrough(),Waypoint.destroyAll(),expect(e.destroy).toHaveBeenCalled(),expect(a.destroy).toHaveBeenCalled()})}),describe("Waypoint.disableAll()",function(){it("calls disable on all waypoints",function(){var e=new Waypoint({element:c("#same1")[0],handler:function(){}});a=new Waypoint({element:c("#same1")[0],handler:function(){}}),spyOn(e,"disable").andCallThrough(),spyOn(a,"disable").andCallThrough(),Waypoint.disableAll(),expect(e.disable).toHaveBeenCalled(),expect(a.disable).toHaveBeenCalled()})}),describe("Waypoint.enableAll()",function(){var e;beforeEach(function(){e=new Waypoint({element:c("#same1")[0],handler:function(){}}),a=new Waypoint({element:c("#same1")[0],handler:function(){}}),Waypoint.disableAll(),spyOn(Waypoint.Context,"refreshAll").andCallThrough(),Waypoint.enableAll()}),it("sets enabled on all waypoints",function(){expect(e.enabled).toBeTruthy(),expect(a.enabled).toBeTruthy()}),it("refreshes all contexts",function(){expect(Waypoint.Context.refreshAll).toHaveBeenCalled()})})})})});